"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.marketBoardItemListing = void 0;
function marketBoardItemListing(reader) {
    return {
        listings: Array(10)
            .fill(null)
            .map(function () {
            return {
                listingId: reader.nextUInt64(),
                retainerId: reader.nextUInt64(),
                retainerOwnerId: reader.nextUInt64(),
                artisanId: reader.nextUInt64(),
                pricePerUnit: reader.nextUInt32(),
                totalTax: reader.nextUInt32(),
                quantity: reader.nextUInt32(),
                itemId: reader.nextUInt32(),
                lastReviewTime: reader.nextUInt32(),
                containerId: reader.nextUInt16(),
                slot: reader.nextUInt16(),
                durability: reader.nextUInt16(),
                spiritbond: reader.nextUInt16(),
                materia: Array(5)
                    .fill(null)
                    .map(function () {
                    var entry = reader.nextUInt16();
                    return {
                        materiaId: entry & (0xff0 >> 4),
                        index: entry & 0xf,
                    };
                }),
                padding1: reader.nextUInt16(),
                padding2: reader.nextUInt32(),
                retainerName: reader.nextString(0x20),
                playerName: reader.nextString(0x20),
                hq: reader.nextUInt8() === 1,
                materiaCount: reader.nextUInt8(),
                onMannequin: reader.nextUInt8() === 1,
                city: {
                    0x01: "Limsa Lominsa",
                    0x02: "Gridania",
                    0x03: "Ul'dah",
                    0x04: "Ishgard",
                    0x07: "Kugane",
                    0x0a: "Crystarium",
                }[reader.nextUInt8()] || "Unknown",
                dyeId: reader.nextUInt16(),
                padding3: reader.nextUInt16(),
                padding4: reader.nextUInt32(),
            };
        })
            .filter(function (listing) { return listing.pricePerUnit > 0; }),
    };
}
exports.marketBoardItemListing = marketBoardItemListing;
//# sourceMappingURL=marketBoardItemListing.js.map