/// <reference types="node" />
import { EventEmitter } from "events";
import { ConstantsList, Message, Region } from "./models";
import { CaptureInterfaceOptions } from "./capture-interface-options";
export declare class CaptureInterface extends EventEmitter {
    private _opcodeLists;
    private _constants;
    private readonly _packetDefs;
    private readonly _superPacketDefs;
    private _opcodes;
    private _segmentQueue;
    private _httpServer;
    private _monitor;
    private readonly _options;
    private expectedPacketIndex;
    private skippedPackets;
    get constants(): ConstantsList | undefined;
    constructor(options: Partial<CaptureInterfaceOptions>);
    start(): Promise<void>;
    private _processNextSegment;
    private spawnMachina;
    stop(): Promise<void>;
    setRegion(region: Region): void;
    private static opcodesToRegistry;
    updateOpcodesCache(): void;
    private _fetchFFXIVOpcodes;
    private _loadOpcodes;
    private _loadConstants;
    private _processSuperPacket;
    private _getOriginKey;
    private _getOrigin;
    private _processSegment;
}
interface CaptureInterfaceEvents {
    ready: () => void;
    error: (err: Error) => void;
    message: (message: Message) => void;
}
export declare interface CaptureInterface {
    on<U extends keyof CaptureInterfaceEvents>(event: U, listener: CaptureInterfaceEvents[U]): this;
    emit<U extends keyof CaptureInterfaceEvents>(event: U, ...args: Parameters<CaptureInterfaceEvents[U]>): boolean;
}
export {};
//# sourceMappingURL=pcap-ffxiv.d.ts.map