"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CaptureInterface = void 0;
var events_1 = require("events");
var models_1 = require("./models");
var json_downloader_1 = require("./json-downloader");
var packet_processors_1 = require("./packet-processors/packet-processors");
var BufferReader_1 = require("./BufferReader");
var http_1 = require("http");
var child_process_1 = require("child_process");
var path_1 = require("path");
var fs_1 = require("fs");
var actor_control_packet_processors_1 = require("./packet-processors/actor-control-packet-processors");
var result_dialog_packet_processors_1 = require("./packet-processors/result-dialog-packet-processors");
var heap_js_1 = __importDefault(require("heap-js"));
var CaptureInterface = /** @class */ (function (_super) {
    __extends(CaptureInterface, _super);
    function CaptureInterface(options) {
        var _this = _super.call(this) || this;
        _this._opcodes = {
            C: {},
            S: {},
        };
        _this._segmentQueue = new heap_js_1.default(function (a, b) { return Number(a.index - b.index); });
        _this._httpServer = undefined;
        _this.expectedPacketIndex = BigInt(0);
        _this.skippedPackets = 0;
        var defaultOptions = {
            region: "Global",
            exePath: path_1.join(__dirname, "./MachinaWrapper/MachinaWrapper.exe"),
            monitorType: "WinPCap",
            port: 13346,
            filter: function () { return true; },
            logger: function (payload) { return console[payload.type](payload.message); },
            winePrefix: "$HOME/.Wine",
            hasWine: false,
        };
        _this._options = __assign(__assign({}, defaultOptions), options);
        if (!fs_1.existsSync(_this._options.exePath)) {
            throw new Error("MachinaWrapper not found in " + _this._options.exePath);
        }
        _this._packetDefs = packet_processors_1.packetProcessors;
        _this._superPacketDefs = {
            actorControl: actor_control_packet_processors_1.actorControlPacketProcessors,
            actorControlSelf: actor_control_packet_processors_1.actorControlPacketProcessors,
            actorControlTarget: actor_control_packet_processors_1.actorControlPacketProcessors,
            resultDialog: result_dialog_packet_processors_1.resultDialogPacketProcessors,
        };
        _this._loadOpcodes().then(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._loadConstants()];
                    case 1:
                        _a.sent();
                        this.emit("ready");
                        return [2 /*return*/];
                }
            });
        }); });
        process.on("exit", function () {
            _this.stop().then(function () {
                process.exit();
            });
        });
        return _this;
    }
    Object.defineProperty(CaptureInterface.prototype, "constants", {
        get: function () {
            return this._constants ? this._constants[this._options.region] : undefined;
        },
        enumerable: false,
        configurable: true
    });
    CaptureInterface.prototype.start = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            try {
                _this.spawnMachina();
                _this._httpServer = http_1.createServer(function (req, res) {
                    var data = [];
                    req.on("data", function (chunk) {
                        data.push(chunk);
                    });
                    req.on("end", function () {
                        var segmentBuffer = Buffer.concat(data);
                        var segmentReader = new BufferReader_1.BufferReader(segmentBuffer);
                        var index = segmentReader.skip(1).nextUInt64();
                        _this._segmentQueue.push({
                            index: index,
                            reader: segmentReader.reset(),
                        });
                        _this._processNextSegment();
                        res.writeHead(200);
                        res.end();
                    });
                }).listen(_this._options.port, "localhost");
                setTimeout(function () {
                    var _a;
                    (_a = _this._monitor) === null || _a === void 0 ? void 0 : _a.stdin.write("start\n", function (err) {
                        if (err) {
                            reject(err);
                        }
                        else {
                            resolve();
                        }
                    });
                }, 200);
            }
            catch (e) {
                reject(e);
            }
        });
    };
    CaptureInterface.prototype._processNextSegment = function () {
        var peek = this._segmentQueue.peek();
        if (peek && peek.index <= this.expectedPacketIndex) {
            var next = this._segmentQueue.pop();
            // This is really just for the compiler because if we're here, there's something to pop.
            if (next) {
                this._processSegment(next.reader);
                this.expectedPacketIndex++;
                this.skippedPackets = 0;
                this._processNextSegment();
            }
        }
        else {
            this.skippedPackets++;
        }
        // If we skipped more than 10 packets, something isn't right, let's just bump to the next available index
        if (this.skippedPackets > 10 && peek) {
            this._options.logger({
                type: "warn",
                message: "Waited for packet #" + this.expectedPacketIndex + " for too long, bumping to " + peek.index + ".",
            });
            this.expectedPacketIndex = peek.index;
            this.skippedPackets = 0;
        }
    };
    CaptureInterface.prototype.spawnMachina = function () {
        var args = [
            "--MonitorType",
            this._options.monitorType,
            "--Region",
            this._options.region,
            "--Port",
            this._options.port.toString(),
        ];
        if (this._options.pid)
            args.push("--ProcessID", this._options.pid.toString());
        if (this._options.hasWine) {
            this._monitor = child_process_1.spawn("WINEPREFIX=\"" + this._options.winePrefix + "\" wine " + this._options.exePath, args);
        }
        else {
            this._monitor = child_process_1.spawn(this._options.exePath, args);
        }
        this._options.logger({
            type: "info",
            message: "MachinaWrapper started with args: " + args.join(" "),
        });
    };
    CaptureInterface.prototype.stop = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var _a;
            (_a = _this._monitor) === null || _a === void 0 ? void 0 : _a.stdin.write("kill\n", function (writeErr) {
                var _a;
                (_a = _this._httpServer) === null || _a === void 0 ? void 0 : _a.close(function (err) {
                    delete _this._httpServer;
                    if (err || writeErr) {
                        reject(err || writeErr);
                    }
                    else {
                        resolve();
                    }
                });
            });
        });
    };
    CaptureInterface.prototype.setRegion = function (region) {
        this._options.region = region;
        this.updateOpcodesCache();
    };
    CaptureInterface.opcodesToRegistry = function (opcodes) {
        return opcodes.reduce(function (acc, entry) {
            var _a;
            return __assign(__assign({}, acc), (_a = {}, _a[entry.opcode] = entry.name, _a));
        }, {});
    };
    CaptureInterface.prototype.updateOpcodesCache = function () {
        var _this = this;
        var _a;
        var regionOpcodes = (_a = this._opcodeLists) === null || _a === void 0 ? void 0 : _a.find(function (ol) { return ol.region === _this._options.region; });
        this._opcodes = {
            C: CaptureInterface.opcodesToRegistry((regionOpcodes === null || regionOpcodes === void 0 ? void 0 : regionOpcodes.lists.ClientZoneIpcType) || []),
            S: CaptureInterface.opcodesToRegistry((regionOpcodes === null || regionOpcodes === void 0 ? void 0 : regionOpcodes.lists.ServerZoneIpcType) || []),
        };
    };
    CaptureInterface.prototype._fetchFFXIVOpcodes = function (file) {
        return __awaiter(this, void 0, void 0, function () {
            var localOpcodesPath, content;
            return __generator(this, function (_a) {
                localOpcodesPath = this._options.localOpcodesPath;
                if (localOpcodesPath) {
                    try {
                        content = fs_1.readFileSync(path_1.join(localOpcodesPath, file), "utf-8");
                        this._options.logger({
                            type: "info",
                            message: "Loading " + file + " from " + localOpcodesPath,
                        });
                        return [2 /*return*/, JSON.parse(content)];
                    }
                    catch (e) { }
                }
                this._options.logger({
                    type: "info",
                    message: "Loading " + file + " from jsdelivr",
                });
                return [2 /*return*/, json_downloader_1.downloadJson("https://cdn.jsdelivr.net/gh/karashiiro/FFXIVOpcodes@latest/" + file)];
            });
        });
    };
    CaptureInterface.prototype._loadOpcodes = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this._fetchFFXIVOpcodes("opcodes.min.json")];
                    case 1:
                        _a._opcodeLists = _b.sent();
                        this.updateOpcodesCache();
                        return [2 /*return*/];
                }
            });
        });
    };
    CaptureInterface.prototype._loadConstants = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this._fetchFFXIVOpcodes("constants.min.json")];
                    case 1:
                        _a._constants = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CaptureInterface.prototype._processSuperPacket = function (typeName, message, reader) {
        var subTypesEnum;
        // Let's get the corresponding enum
        switch (typeName) {
            case "actorControl":
            case "actorControlSelf":
            case "actorControlTarget":
                subTypesEnum = models_1.ActorControlType;
                break;
            case "resultDialog":
                subTypesEnum = models_1.ResultDialogType;
                break;
            default:
                this._options.logger({
                    type: "error",
                    message: "Got super packet of type " + typeName + " with super processors but no type enum.",
                });
                return message;
        }
        var subTypeName = subTypesEnum[message.parsedIpcData.category];
        if (!subTypeName) {
            message.subType = "unknown" + message.parsedIpcData.category;
            // Unknown subtype, return packet as-is
            return message;
        }
        subTypeName = subTypeName[0].toLowerCase() + subTypeName.slice(1);
        message.subType = subTypeName;
        var superProcessor = this._superPacketDefs[typeName][subTypeName];
        if (!superProcessor) {
            // No processor for this sub packet, return packet as-is
            return message;
        }
        message.parsedIpcData = superProcessor(message.parsedIpcData, reader, this.constants, this._options.region);
        return message;
    };
    CaptureInterface.prototype._getOriginKey = function (originIndex) {
        return [null, "C", "S"][originIndex];
    };
    CaptureInterface.prototype._getOrigin = function (originKey) {
        return { C: "send", S: "receive" }[originKey];
    };
    CaptureInterface.prototype._processSegment = function (dataReader) {
        var originIndex = dataReader.nextUInt8();
        var origin = this._getOriginKey(originIndex);
        if (!origin) {
            this._options.logger({
                type: "error",
                message: "Received a packet with origin " + originIndex + ", should be 1 or 2.",
            });
            return;
        }
        var reader = dataReader.skip(8).restAsBuffer(true);
        var header = {
            size: reader.nextUInt32(),
            sourceActor: reader.nextUInt32(),
            targetActor: reader.nextUInt32(),
            segmentType: reader.nextUInt32(),
            operation: this._getOrigin(origin),
        };
        if (header.segmentType === models_1.SegmentType.Ipc) {
            var opcode = reader.skip(2).nextUInt16();
            var ipcData = reader.skip(12).restAsBuffer();
            var typeName = this._opcodes[origin][opcode] || "unknown";
            typeName = typeName[0].toLowerCase() + typeName.slice(1);
            var message = {
                header: header,
                opcode: opcode,
                type: typeName,
            };
            if (this._options.filter(header, typeName)) {
                // Unmarshal the data, if possible.
                if (this._packetDefs[typeName] && this._constants) {
                    var processorName = typeName;
                    var ipcDataReader = new BufferReader_1.BufferReader(ipcData);
                    var processor = this._packetDefs[processorName];
                    message.parsedIpcData = processor(ipcDataReader, this._constants[this._options.region], this._options.region);
                    // If this is a super packet
                    if (this._superPacketDefs[typeName]) {
                        message = this._processSuperPacket(typeName, message, ipcDataReader.reset());
                    }
                }
                this.emit("message", message);
            }
        }
    };
    return CaptureInterface;
}(events_1.EventEmitter));
exports.CaptureInterface = CaptureInterface;
//# sourceMappingURL=pcap-ffxiv.js.map